import 'dart:async';
import 'package:flutter/material.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'chat_config_template.dart';

// final msgsProvider=StateNotifierProvider<msgsController,List<msg>?>((ref){
//   final cnl=ref.watch(selectedChannelPvd).state;
//   final offsetMsg=ref.read(msgOffsetPvd)[0];
//   if(offsetMsg==null) return msgsController(cnl,ref.read,[]);
//   else return msgsController(cnl,ref.read,[offsetMsg]);
// });

class msgsController<C,M> extends StateNotifier<List<M>?>{
  final Reader read;
  final C? cnl;
  final tempConfig_Msg<C,M> config;
  late List<M> cache;
  // late bool streamInCache;

  @protected
  StreamSubscription<List<M>>? msgSub;

  Future<Iterable<M>>loadb4(DateTime t,{int lmt=10})async=>await config.firestore
      .collection(config.getcPath(cnl!))
      .orderBy("time",descending: true)
      .limit(lmt)
      .startAfter([t.toIso8601String()])
      .get()
      .then((v) => v.docs.map((e) => config.msgFromDoc(e, cnl!)));
  Future<Iterable<M>>loadaf(DateTime t,{int lmt=10})async=>await config.firestore
      .collection(config.getcPath(cnl!))
      .orderBy("time",descending: true)
      .limit(lmt)
      .endBefore([t.toIso8601String()])
      .get()
      .then((v) => v.docs.map((e) => config.msgFromDoc(e, cnl!)));

  msgsController(this.cnl,this.read,this.cache,{required this.config}) : super(null) {
    // streamInCache=false;
    msgSub?.cancel();
    if(cnl!=null){
      if(cache.isEmpty)initStream();
      else loadOffset();//.then((v)=>initStream());
    }
  }

  void initStream(){
    assert(cnl!=null);
    if(msgSub!=null)return;
    var qr=config.firestore.collection(config.getcPath(cnl!))
        .orderBy("time",descending: true);
    if(cache.isNotEmpty)qr=qr.endBefore([config.getTime(cache.first).toIso8601String()]);
    msgSub=qr
        .limit(7)
        .snapshots()
        .map((e) => e.docs.map((e) => config.msgFromDoc(e,cnl!)).toList())
        .listen((event) {
          if(mounted){
            if(event.isNotEmpty) {state=List.of(precess(event));}
            else {state ??= [];}
          }});
  }

  @override
  void dispose() {
    endStream();
    // TODO: implement dispose
    super.dispose();
  }

  void endStream(){
    msgSub?.pause();
    msgSub?.cancel();
  }

  List<M> precess(List<M>stream){
    // if(stream.isEmpty){
    //   return cache;}
    stream.sort((a,b)=>config.getTime(b).compareTo(config.getTime(a)));
    // if(cache.isEmpty){
    //   streamInCache=true;
      cache.insertAll(0,stream);//}
    // cache.sort((a,b)=>b.time.compareTo(a.time));
    ///if stream and cache overlaps
    // if(config.getTime(stream.last).compareTo(config.getTime(cache.first))<=0){
    //   streamInCache=true;
    //   final List<M> added=[];
    //   for(int i=0;i<stream.length;i++){
    //     if(config.getId(stream[i])!=config.getId(cache[0])){
    //       added.insert(0, stream[i]);}
    //     else{ break;}
    //   }
    //   cache.insertAll(0, added);}
    ///if cache doesn't reach stream
    // else{
    //   streamInCache=false;
    // }
    return cache;
  }

  Future<void> loadB4() async{
    if(read(config.loadingPvd)||cache.isEmpty)return;
    read(config.loadingPvd.state).state=true;
    final pre=await loadb4(config.getTime(cache.last));
    cache.addAll(pre);
    state=List.of(cache);
    read(config.loadingPvd.state).state=false;
  }

  Future<void> loadAf() async{
    if(msgSub!=null)return;
    if(read(config.loadingPvd)||cache.isEmpty)return;
    read(config.loadingPvd.state).state=true;
    final post=await loadaf(config.getTime(cache.first));
    cache.insertAll(0,post);
    state=List.of(cache);
    if(post.length<10)initStream();
    read(config.loadingPvd.state).state=false;
  }

  Future<void> loadOffset()async{
    ///prevent setState while building message view
    ///todo: consider pause msgSub to stop stream, since could be
    ///      at same channel different searched msg,
    ///      but currently just rebuild whole provider
    if(read(config.loadingPvd))return;
    Future.microtask(() => read(config.loadingPvd.state).state=true);
    final pre=loadb4(config.getTime(cache.last))
        .then((v){
          cache.addAll(v);
        });
    final post=loadaf(config.getTime(cache.first),lmt: 2)
        .then((v){
          cache.insertAll(0,v);
          return v.length;
        });
    final r=await Future.wait([pre,post]);
    state=List.of(cache);
    if(r[1]!<2)initStream();
    read(config.loadingPvd.state).state=false;
  }
}