
import 'package:algolia/algolia.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:pc_plugins/controllers/repository_template.dart';

import '../custom_exception.dart';

class tempConfig<T>{
  final String pageid;
  final int defaultPSize;
  final StateProvider<String?>? dialogC;
  final StateProvider<CustomException?>? exDialogC;
  final Provider<baseTRepo<T>> dataSrcPvd;

  // ///for repository search
  // final String Function(T d) getId;
  //
  // ///for simple dialog search
  // final T Function(AlgoliaObjectSnapshot d) getfromAlg;
  // //shown on suggestions
  // final List<String> attributesAlgo;

  final Function(Reader)? onSearchChange;
  final Function(Reader)? onSearchClick;
  tempConfig({
    required this.dataSrcPvd,
    required this.pageid,
    // required this.getId,
    // required this.getfromAlg,
    // this.attributesAlgo=const ["objectID"],
    this.onSearchChange,
    this.onSearchClick,
    this.defaultPSize=10,
    this.dialogC,this.exDialogC});
}

class repo_tempConfig<T>extends tempConfig<T>{
  ///for repository search
  final String Function(T d) getId;
  final T Function(T d,String id) updateId;
  final List<String>? scopeFilters;
  final bool Function(T,String)? isUnread;

  repo_tempConfig({
    required dataSrcPvd,
    required pageid,
    required this.getId,
    required this.updateId,
    this.scopeFilters,
    this.isUnread,
    onSearchChange,
    onSearchClick,
    defaultPSize=10,
    dialogC,exDialogC}) : super(
      dataSrcPvd:dataSrcPvd,
      pageid:pageid,
    onSearchChange: onSearchClick,
    onSearchClick: onSearchClick,
    defaultPSize: defaultPSize,
    dialogC: dialogC,
    exDialogC: exDialogC
  );
}

class sug_tempConfig<T>extends tempConfig<T>{
  ///for simple dialog search
  final T Function(AlgoliaObjectSnapshot d) getfromAlg;
  //shown on suggestions
  final List<String> attributesAlgo;

  sug_tempConfig({
    required dataSrcPvd,
    required pageid,
    required this.getfromAlg,required this.attributesAlgo,
    onSearchChange,
    onSearchClick,
    defaultPSize=10,
    dialogC,exDialogC}) : super(
      dataSrcPvd:dataSrcPvd,
      pageid:pageid,
      onSearchChange: onSearchClick,
      onSearchClick: onSearchClick,
      defaultPSize: defaultPSize,
      dialogC: dialogC,
      exDialogC: exDialogC
  );
}
