import 'dart:math';

import 'package:algolia/algolia.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';

final searchingPvd=AutoDisposeStateProviderFamily<bool,String>((_,id)=>false);

final pageIndexPvd=StateProviderFamily<pageInd,String>((_,i)=>pageInd(end: 0, total: 0));

class pageInd{
  late int start;
  late int end;
  late int? total;
  late int page;
  // late bool issearch;
  String? query;
  late Map<String,dynamic>? data;
  // bool searching=false;
  pageInd({this.query, this.start=0,required this.end,
    required this.total,this.page=0,this.data=null
  });
  pageInd.fromAlgo(Map<String,dynamic> q){
    data=q;
    start=q["hitsPerPage"]*q["page"]+1;
    total=q["nbHits"];
    page=q["page"];
    end=min(start+(q["hitsPerPage"] as int)-1, total??99999);
    query=q["query"];
    // issearch=false;
  }

  pageInd.fromTwiMeta(Map<String,dynamic> m){
    if(m["meta"]==null)return;

    final int pSize=m["meta"]["page_size"];
    page=m["meta"]["page"];
    start=page*pSize+1;
    final key=m.keys.singleWhere((e) => e!="meta");
    total=null;
    end=start-1+min(pSize,m[key].length);
  }

  get pageNb{
    return start~/(end-start+1);
  }
  get text{
    return "$start-$end ${total==null?"":"/$total"}";
  }
  get canNext{
    return total==null||end<total!;
  }
  get canPre{
    return start>1;
  }
}