import 'dart:math';

import 'package:flutter/material.dart';

class cTheme extends InheritedWidget {
  static cTheme of(BuildContext context) => context.dependOnInheritedWidgetOfExactType<cTheme>()!;

  const cTheme({required Widget child, Key? key, this.data=const ctData()
  }): super(key: key, child: child);

  final ctData data;

  @override
  bool updateShouldNotify(cTheme oldWidget) => false;
}

class ctData{
  const ctData({
    this.card=const Color(0xFFF7EFE9),
    this.upper_bg=const Color(0xFFF9F4F0),
    this.scf_bg=const Color(0xFFF0CEB7),
    this.textColor=const Color(0xFF6A515E),
    this.but=const MaterialColor(0xFFDEA27A, scf_bg_mtr)
  });
  final Color card;
  final Color upper_bg;
  final Color scf_bg;

  ///not using it yet
  final Color textColor;

  final MaterialColor but;

  ctData copyWith({Color? card, Color? upper_bg, Color? scf_bg,
    Color? textColor, MaterialColor? but})=>
      ctData(card:card??this.card,upper_bg:upper_bg??this.upper_bg,
          scf_bg:scf_bg??this.scf_bg, textColor:textColor??this.textColor,but:but??this.but);

  ctData.fromMap(Map<String,dynamic>?m):
        this.card=Color((m?["card"])??0xFFF7EFE9),
        this.upper_bg=Color((m?["upper_bg"])??0xFFF9F4F0),
        this.scf_bg=Color((m?["bgColor"])??0xFFF0CEB7),
        this.textColor=Color((m?["textColor"])??0xFF6A515E),
        this.but=(m?["but"])==null?const MaterialColor(0xFFDEA27A, scf_bg_mtr)
            :makeMColor(Color(m?["but"]));

  toMap()=>{"card":card.value,"upper_bg":upper_bg.value,
    "bgColor":scf_bg.value,"textColor":textColor.value,"but":but[500]!.value};
}

MaterialColor makeMColor(Color c){
  c=c.withAlpha(255);
  final int r=c.red;
  final int b=c.blue;
  final int g=c.green;
  final c1=c.withRed((r*0.9+4).ceil())
      .withBlue((b*0.9+4).ceil()).withGreen((g*0.9+4).ceil());
  final c2=c.withRed(min(255,(r*1.03+2).ceil()))
      .withBlue(min(255,(b*1.03+2).ceil()))
      .withGreen(min(255,(g*1.03+2).ceil()));
  final c3=c2.withRed(min(255,(c2.red*1.03+2).ceil()))
      .withBlue(min(255,(c2.blue*1.03+2).ceil()))
      .withGreen(min(255,(c2.green*1.03+2).ceil()));
  return MaterialColor(c.value, {
    50: c.withAlpha(0x11),
    100: c.withAlpha(0x33),
    200: c.withAlpha(0x66),
    300: c.withAlpha(0x99),
    400: c.withAlpha(0xdd),
    500: c,
    600: c1.withAlpha(0x44),
    700: c2.withAlpha(0x66),
    800: c2.withAlpha(0x99),
    900: c2,
    1000: c3
  });
}

Color withWhite(Color c,int n){
  final g=max(min(c.green+n,255),0);
  final r=max(min(c.red+n,255),0);
  final b=max(min(c.blue+n,255),0);
  return Color.fromARGB(c.alpha, r, g, b);
}
const Color card=Color(0xFFF7EFE9);
const Color upper_bg=Color(0xFFF9F4F0);
const Color scf_bg=Color(0xFFF0CEB7);
const Color textColor=Color(0xFF6A515E);
const Color grey_ts=Color(0xffA59CA0);
const Color drawerColor=Color(0xFFFDF9F9);

// const butC=scf_bg_mtr[500];
const MaterialColor but=MaterialColor(0xFFDEA27A, scf_bg_mtr);
const Map<int, Color> scf_bg_mtr = const{
  50: Color(0x11DEA27A),
  100: Color(0x33DEA27A),
  200: Color(0x66DEA27A),
  300: Color(0x99DEA27A),
  400: Color(0xddDEA27A),
  500: Color(0xFFDEA27A),
  600: Color(0x44d08e60),
  700: Color(0x66F0Ae80),
  800: Color(0x99F0Ae80),
  900: Color(0xffF0Ae80),
  1000: Color(0xFFe8bfa3)
};

const Color shadow=Colors.black26;
