
import 'others.dart';

String formated(DateTime d,{bool min=false,bool date=true}){
  final datee=months[d.month-1]+" "+d.day.toString()+
      (d.day==1?"st":d.day==2?"nd":d.day==3?"rd":"th")+", "+d.year.toString();
  final minu=" ${d.hour}:${d.minute<10?"0":""}${d.minute}";

  return (date?datee:"")+ (min?minu:"");
}


///format xx:x to xx:0x pm
String formatTod(String? t, {int? n}){                                            //n = 1 for start time, n = 2 for end time
  if(t==null)return n!=null?setAvailabilityTexts[n]:ns;

  List<String> r=t.split(":");
  final hour=int.parse(r[0]);
  return addLeadingZeroIfNeeded(hour%12)+":"+
      addLeadingZeroIfNeeded(int.tryParse(r[1])!)+(hour>12?" PM":" AM");
}

String formatDate_mdd(DateTime t){
  return "${t.month}/${t.day}";
}

String formatTod_intL(List<int> r){
  return addLeadingZeroIfNeeded(r[0]%12)+":"+
      addLeadingZeroIfNeeded(r[1])+(r[0]>=12?" PM":" AM");
}

String addLeadingZeroIfNeeded(int value) {
  if (value < 10)
    return '0$value';
  return value.toString();
}

String add0IfNeeded_str(String value) {
  if (value .length<2)
    return '0$value';
  return value;
}

String? loc2utc(DateTime? d){
  return d?.toUtc().toIso8601String();
}

DateTime? utc2loc(String? s){
  return DateTime.tryParse(s??"")?.toLocal();
}

DateTime utc2locRq(String s){
  return DateTime.parse(s).toLocal();
}

String unformatPhone(String n,{bool trim1=true}){
  n=n.replaceAll("+", "");
  n=n.replaceAll("-", "");
  n=n.replaceAll("(", "");
  n=n.replaceAll(")", "");
  if(trim1&&n.startsWith("1"))n=n.substring(1);
  return n;
}


String CountDownNoti(Duration dr){
  int d=dr.inDays;
  int h=dr.inHours%24;
  int m=dr.inMinutes%60;
  int s=dr.inSeconds%60;
  return (d>0?"$d Days ":"")+(h>0?"$h Hours ":"")+(m>0?"$m Mins ":"")+(s>0?"$s Secs":"");
}


Duration? secsFromNow(DateTime? t) {
  final DateTime now = DateTime.now();
  if(t==null)return null;
  t=t.add(Duration(days: 3));
  return t.isBefore(now)?null:t.difference(now);
}

String formateDollar(double m,{bool addSign=true}){
  String mStr=m.toStringAsFixed(2);
  String rs=mStr.substring(mStr.length-3);
  mStr=mStr.substring(0,mStr.length-3);
  while(mStr.length>3){
    rs=","+mStr.substring(mStr.length-3)+rs;
    mStr=mStr.substring(0,mStr.length-3);
  }
  rs=addSign?("\$ "+mStr+rs):(mStr+rs);
  return rs;
}

String? formateDollarStr(String m,{bool addSign=true}){
  if(m.startsWith("\$"))m=m.substring(1);
  m=m.replaceAll(",", "");
  final s=double.tryParse(m);
  if(s==null)return null;
  return formateDollar(s,addSign:addSign);
}

extension DateTimeExtension on DateTime {
  DateTime next(int day) {
    return this.add(
      Duration(days: (day - this.weekday) % DateTime.daysPerWeek,),
    );
  }
}