import 'dart:math';

import 'package:flutter/material.dart';


class bg extends CustomPainter{
  // static const double dy=27;
  bg({required this.color});
  static const double r=9;
  final Color color;
  @override
  void paint(Canvas canvas, Size size) {
    Paint paint=Paint()..color=color
      ..style=PaintingStyle.fill;//..strokeWidth=3;
    final dy=size.height*0.375;
    Path path=Path();
    path.moveTo(0, 0);
    path.lineTo(0, dy);
    path.quadraticBezierTo(r/3, dy+r*2/3, r, dy+r);
    path.lineTo(size.width-r, dy+r);
    path.quadraticBezierTo(size.width-r/3, dy+r*2/3, size.width, dy);
    path.lineTo(size.width, 0);
    path.lineTo(0, 0);

    // canvas.drawColor(scf_bg, BlendMode.src);
    canvas.drawPath(path, paint);
    // TODO: implement paint
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return false;
  }
}

class table_sign extends CustomPainter{
  final double sidePad;
  final double topPad;
  final Color color;
  table_sign({this.sidePad=100,this.topPad=0,required this.color});
  @override
  void paint(Canvas canvas, Size size) {
    Paint paint=Paint()..color=color
      ..style=PaintingStyle.fill;//..strokeWidth=3;
    Path path=Path();
    path.moveTo(sidePad, topPad);
    path.quadraticBezierTo(size.width/2, 9+topPad , size.width-sidePad, 0+topPad);
    path.quadraticBezierTo(size.width/2, 16+topPad, sidePad, 0+topPad);

    // canvas.drawColor(scf_bg, BlendMode.src);
    canvas.drawPath(path, paint);

    paint=Paint()..color=color
      ..style=PaintingStyle.stroke..strokeWidth=9;
    path.moveTo(sidePad+(size.width-2*sidePad)*0.4, 12+topPad);
    path.lineTo(sidePad+(size.width-2*sidePad)*0.4, size.height-4+topPad);
    path.moveTo(sidePad+(size.width-2*sidePad)*0.6, 12+topPad);
    path.lineTo(sidePad+(size.width-2*sidePad)*0.6, size.height-4+topPad);
    canvas.drawPath(path, paint);
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return false;
  }
}

class progression_rad extends CustomPainter{
  final double percent;
  final double r;
  final Color color;

  static const double iconSize=5;
  progression_rad({required this.percent,this.r=iconSize/2-iconSize/8,
    required this.color});
  static const green=Colors.green;
  @override
  void paint(Canvas canvas, Size size) {
    double w=r/5;
    double inner=r-w;
    double cx=size.width/2;
    double cy=size.height/2;
    canvas.drawCircle(Offset(cx, cy), r, Paint()..color=color
      ..style=PaintingStyle.stroke..strokeWidth=w);
    // canvas.drawCircle(c, radius, paint);
    Paint paint=Paint()..color=color
      ..style=PaintingStyle.fill;//..strokeWidth=3;
    Path path=Path();
    path.moveTo(cx, cy);
    path.lineTo(cx, cy-r+w);
    final double dgr=2*pi*percent;
    path.arcToPoint(Offset(cx+inner*sin(dgr), cy-inner*cos(dgr)),radius: Radius.circular(inner),largeArc: percent>0.5);
    path.lineTo(cx, cy);

    canvas.drawPath(path, paint);
    // TODO: implement paint
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return this.percent==(oldDelegate as progression_rad).percent;
  }
}

class ctc_rad extends CustomPainter{
  final double percent;
  final double r;
  final Color color;
  ctc_rad({required this.percent,required this.color,this.r=16});
  static const green=Colors.green;
  @override
  void paint(Canvas canvas, Size size) {
    Paint paint =Paint()..color=Colors.grey
      ..style=PaintingStyle.stroke..strokeWidth=9;
    double cx=size.width/2;
    double cy=size.height/2;
    canvas.drawCircle(Offset(cx, cy), r, paint);

    Path path=Path();
    path.moveTo(cx, cy-r);
    final double dgr=2*pi*percent;
    path.arcToPoint(Offset(cx-r*sin(dgr), cy-r*cos(dgr)),
        radius: Radius.circular(r),largeArc: percent>0.5,clockwise: false);

    canvas.drawPath(path, paint..color=color);
    // TODO: implement paint
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return this.percent==(oldDelegate as ctc_rad).percent;
  }
}

class segmented_rad extends CustomPainter{
  final int step;
  final double r;
  final Color color;
  final int stage_total;
  segmented_rad({required this.step,required this.color,required this.stage_total, this.r=16});
  static const breakL=0.15;
  
  @override
  void paint(Canvas canvas, Size size) {
    Paint paint =Paint()..color=Colors.green
      ..style=PaintingStyle.stroke..strokeWidth=10;
    double cx=size.width/2;
    double cy=size.height/2;
    final p=10;
    Path path1=Path()..moveTo(cx, cy-r+p);
    final dgr=2*pi*(step+1)/stage_total;
    path1.arcToPoint(Offset(cx+r*sin(dgr), cy-r*cos(dgr)+p),
        radius: Radius.circular(r),largeArc: dgr>pi);
    canvas.drawPath(path1, paint);

    path1=Path()..moveTo(cx+r*sin(dgr), cy-r*cos(dgr)+p);
    path1.arcToPoint(Offset(cx, cy-r+p),
        radius: Radius.circular(r),largeArc: dgr<pi);
    canvas.drawPath(path1, paint..color=color);

    path1=Path()..moveTo(cx, cy-r+p);
    for(int i=0;i<=stage_total;i++){
      final dgr=2*pi*(i+1)/stage_total-breakL;
      path1.moveTo(cx+r*sin(dgr), cy-r*cos(dgr)+p);
      path1.arcToPoint(Offset(cx+r*sin(dgr+breakL), cy-r*cos(dgr+breakL)+p),
          radius: Radius.circular(r));
    }
    canvas.drawPath(path1, paint..color=Colors.white);
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return this.step==(oldDelegate as segmented_rad).step;
  }
}

const butLoading=SizedBox(width: 27,height:27,child:Loading(opacity: 0,padding: 9,));

class Loading extends StatelessWidget {
  final double opacity;
  final String? text;
  final double? padding;
  final double? circSize;
  final Color? color;
  const Loading({this.opacity=0.2,this.text,this.padding,
    this.circSize,this.color});

  @override
  Widget build(BuildContext context) {
    final circ=Container(height: circSize, width: circSize, child: CircularProgressIndicator(strokeWidth: 2,
      valueColor: AlwaysStoppedAnimation<Color>(color??Colors.white60),
    ),);
    return Container(padding: padding==null?null:EdgeInsets.all(padding!),
      child: Center(
        child: text==null?circ:Row(mainAxisSize:MainAxisSize.min,
          children: [Text(text!,style: Theme.of(context).textTheme.headline3),
            circ],),
      ),
      color: Colors.white.withOpacity(opacity),
    );
  }
}


class bgSignIn extends CustomPainter{
  // static const double dy=27;
  static const double r=9;
  final Color color;
  bgSignIn({required this.color});
  @override
  void paint(Canvas canvas, Size size) {
    Paint paint=Paint()..color=color
      ..style=PaintingStyle.fill;//..strokeWidth=3;
    final double dy=300.0;
    Path path=Path();
    path.moveTo(0, 0);
    path.lineTo(0, dy);
    // path.quadraticBezierTo(r/3, dy+r*2/3, r, dy+r);
    path.lineTo(size.width, dy);
    // path.quadraticBezierTo(size.width-r/3, dy+r*2/3, size.width, dy);
    path.lineTo(size.width, 0);
    path.lineTo(0, 0);

    // canvas.drawColor(scf_bg, BlendMode.src);
    canvas.drawPath(path, paint);
    // TODO: implement paint
  }

  @override
  bool shouldRepaint(covariant CustomPainter oldDelegate) {
    return false;
  }
}
