library pc_plugins;
import 'package:flutter/material.dart';


class BlinkingTextAnimation extends StatefulWidget {
  final Color fromColor;
  final Color toColor;
  final String text;
  final TextStyle? style;
  final AnimationController controller;
  BlinkingTextAnimation({required this.controller,
    required this.text,this.style,
    required this.fromColor,this.toColor=Colors.red});
  @override
  _BlinkingAnimationState createState() => _BlinkingAnimationState();
}

class _BlinkingAnimationState extends State<BlinkingTextAnimation>
    with SingleTickerProviderStateMixin {
  late Animation<Color?> animation;
  // late AnimationController controller;

  int time=3;
  initState() {
    super.initState();

    // controller = AnimationController(
    //     duration: const Duration(milliseconds: 500), vsync: this);

    final CurvedAnimation curve =
    CurvedAnimation(parent: widget.controller, curve: Curves.ease);

    animation =
        ColorTween(begin: widget.fromColor, end: widget.toColor).animate(curve);

    animation.addStatusListener((status) {
      if (status == AnimationStatus.completed) {
        widget.controller.reverse();
      } else if (status == AnimationStatus.dismissed) {
        if(time>0) {
          widget.controller.forward();
          time--;
        }else{
          time=3;return;
        }
      }
      setState(() {});
    });

    // controller.forward();
  }

  @override
  Widget build(BuildContext context) {
    return AnimatedBuilder(
        animation: animation,
        builder: (BuildContext context, Widget? child) {
          return Container(
            child: Text(widget.text,maxLines: 4,
                style: (widget.style??(Theme.of(context).textTheme.caption))
                    ?.copyWith(color: animation.value)),
          );
        });
  }

  @override
  dispose() {
    widget.controller.dispose();
    super.dispose();
  }
}