import 'dart:html';
import 'dart:typed_data';

import 'CrossPicker.dart';

class WebPicker implements CrossPicker{
  Future<Uint8List?> pick()async{
    FileUploadInputElement uploadInput = FileUploadInputElement();
    uploadInput.click();

    return uploadInput.onChange.first.then((e) {
      // read file content as dataURL
      final files = uploadInput.files;
      if(files==null)return null;
      if (files.length == 1) {
        final file = files[0];
        FileReader reader =  FileReader();

        // reader.onError.listen((fileEvent) {
        //   throw CustomException(message: "some error occured while reading file");
        // });

        reader.readAsArrayBuffer(file);

        return reader.onLoadEnd.first.then((e) {
          return reader.result as Uint8List?;
        });
      }
    });
  }

  Future<List<Uint8List?>?> pick_multi()async{
    FileUploadInputElement uploadInput = FileUploadInputElement()..multiple=true..draggable=true;
    uploadInput.click();

    return uploadInput.onChange.first.then((e) {
      // read file content as dataURL
      final files = uploadInput.files;
      if(files==null)return null;
      return Future.wait(files.map((e) {
        FileReader reader =  FileReader();

        // reader.onError.listen((fileEvent) {
        //   throw CustomException(message: "some error occured while reading file");
        // });

        reader.readAsArrayBuffer(e);

        return reader.onLoadEnd.first.then((e) {
          return reader.result as Uint8List?;
        });
      }));
    });
  }
}

CrossPicker init()=>WebPicker();