import 'dart:math';

import 'package:flutter/material.dart';
import 'package:pc_plugins/utils/utils.dart';


const double height = 300;
const double dialog_width = 400;
const EdgeInsets padd = EdgeInsets.all(15);
const EdgeInsets innerPadd = EdgeInsets.all(20);

class gnr_dialog extends StatelessWidget {
  final String text;
  final bool duz;
  final String? yes;
  final String? no;
  final ButtonStyle? yesStyle;
  final ButtonStyle? noStyle;
  final double? borderRadius;

  gnr_dialog(this.text, this.duz,{
    this.borderRadius=20,this.yes,this.no,this.yesStyle,this.noStyle});

  @override
  Widget build(BuildContext context) {
    return dialogFrame(child:Container(
          padding: padd,
          width: min(MediaQuery.of(context).size.width * 0.5, dialog_width),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            mainAxisSize: MainAxisSize.min,
            children: [
              Center(
                  child: Text(
                text,
                textAlign: TextAlign.center,
                style: TextStyle(
                    fontFamily: "Merriweather",
                    fontWeight: FontWeight.w500,
                    fontSize: 16,
                    // color: cTheme.of(context).data.but,
                    decoration: TextDecoration.none),
              )),
              SizedBox(height: 40),
              Row(
                mainAxisAlignment: !duz
                    ? MainAxisAlignment.center
                    : MainAxisAlignment.spaceBetween,
                children: [
                  TextButton(
                    onPressed: () {Navigator.of(context).pop(true);},
                    child: Text(yes??"Yes"),
                    style: yesStyle,
                  ),
                  if (duz)
                    TextButton(
                        onPressed: () {
                          Navigator.of(context).pop(false);
                        },
                        child: Text(no??"No"),
                        style: noStyle),
                ],
              )
            ],
          ),
        ),borderRadius:borderRadius
      );
  }
}


class dialogFrame extends StatelessWidget {
  final Widget child;
  final double? borderRadius;
  const dialogFrame({required this.child,this.borderRadius=20,Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
        padding: padd,
        child: Dialog(
            shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.all(Radius.circular(borderRadius??20))),
            backgroundColor: cTheme.of(context).data.upper_bg,
            elevation: 24, child:Padding(padding: innerPadd,
            child:child)));
  }
}


