import 'dart:typed_data';

import 'package:community_material_icon/community_material_icon.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_hooks/flutter_hooks.dart';
import 'package:pc_plugins/utils/utils.dart';

class pictureTile extends HookWidget {
  final String? pictureUrl;
  final Uint8List? file;
  final IconData placeholderIcon;
  final double height;
  final double width;
  final bool zoomable;
  final void Function()? onTap;
  // final ValueNotifier<bool> loading;

  pictureTile({Key? key, this.pictureUrl, this.placeholderIcon = Icons.error_rounded,
    this.height = 100, this.width = 0, this.zoomable = true, this.onTap, this.file}):super(key:key);

  @override
  Widget build(BuildContext context) {
    // BoxConstraints imageBoxConstraints = BoxConstraints(maxHeight: 100);
    double borderRadius = 10;
    var hoverState = useState(false);
    final ac=useAnimationController(duration: dura);
    final a = CurvedAnimation(parent: ac, curve: Curves.easeInOut);

    // TODO: implement build
    return GestureDetector(
      onTap: onTap?? (){
        if(zoomable)
        Navigator.of(context).push(PageRouteBuilder(
            opaque: false,
            pageBuilder: (BuildContext ctx, _, __)
            {if(pictureUrl!=null&&pictureUrl!.length!=0) return pictureFullScr(pictureUrl!); else return Container();},
          transitionsBuilder: (context, animation, secondaryAnimation, child) {
            const begin = Offset(0.0, 1.0);
            const end = Offset.zero;
            const curve = Curves.ease;

            var tween = Tween(begin: begin, end: end).chain(CurveTween(curve: curve));

            return SlideTransition(
              position: animation.drive(tween),
              child: child,
            );
          },
        ));
      },
      child: MouseRegion(cursor: zoomable?SystemMouseCursors.zoomIn:onTap!=null?SystemMouseCursors.click:SystemMouseCursors.basic,
        onHover: zoomable?(e){hoverState.value=true;ac.forward();}:null,
        onExit: zoomable?(e){ac.reverse();if(ac.isCompleted)hoverState.value=false;}:null,
        child: ClipRRect(borderRadius: BorderRadius.all(Radius.circular(borderRadius)),
          child:
          ((pictureUrl!=null&&pictureUrl!.length!=0)||file!=null)?Container(
            height: height,
            width: width==0?null:width,
            child: Stack(fit: StackFit.passthrough,
              children: [
                Container(width: width==0?null:width,
                  child: file==null?Image.network(pictureUrl!, filterQuality: FilterQuality.medium,
                    loadingBuilder: (BuildContext context, Widget child,ImageChunkEvent? loadingProgress){
                    if (loadingProgress == null) return child;
                    return Container(
                      child: Center(
                        child: SizedBox(
                          height: 20, width: 20,
                          child: CircularProgressIndicator(
                            strokeWidth: 1,
                            color: but,
                            value: loadingProgress.expectedTotalBytes != null ?
                            loadingProgress.cumulativeBytesLoaded / loadingProgress.expectedTotalBytes!
                                : null,
                          ),
                        ),
                      ),
                    );
                  },
                    height: height,
                      width: width==0?null:width,
                      isAntiAlias: true,
                      fit: width==0?BoxFit.fitHeight:BoxFit.cover
                  ):
                  Image.memory(file!),
                ),
                if(hoverState.value&&zoomable)Positioned.fill(
                  child: AnimatedBuilder(animation: a,
                      builder: (ctx,c)=>Container(decoration: BoxDecoration(color: Colors.black45.withOpacity(0.4*a.value)),
                    child: Center(child: Icon(CommunityMaterialIcons.magnify, color: Colors.white.withOpacity(ac.value),)),)),
                ),
                // if(hoverState.value)Container(decoration: BoxDecoration(color: Colors.black45.withOpacity(0.2)),
                //   child: Center(child: Icon(CommunityMaterialIcons.magnify)),)
              ],
            ),
          ):
          Container(
            height: height, width: width==0?null:width,
            decoration: BoxDecoration(borderRadius: BorderRadius.all(Radius.circular(borderRadius)), color: Colors.white),
              child: Icon(placeholderIcon, size: height*0.9,)),
        ),
      ),
    );
  }
}

class pictureFullScr extends HookWidget {
  final String picUrl;
  final String exitCaption;

  pictureFullScr(this.picUrl,{this.exitCaption="close"});

  @override
  Widget build(BuildContext context) {
    // TODO: improve closing behaviour
    return Scaffold(
      backgroundColor: Colors.black.withOpacity(0.9),
      body: GestureDetector(
        child: Stack(
          children: [
            Center(
              child: Hero(tag: 'imageHero', child: Image.network(picUrl,width: MediaQuery.of(context).size.width*0.8, height: MediaQuery.of(context).size.width*0.8, fit: BoxFit.contain,),
              ),),
            Row(mainAxisAlignment: MainAxisAlignment.center,
              children: [Text(exitCaption, style: TextStyle(color: Colors.white),),],
            )
          ],
        ),
        onTap: () {
          Navigator.of(context).pop();
          },
      ),
    );  }

}