import 'dart:html';
import 'package:flutter/material.dart';
import 'package:pc_plugins/utils/utils.dart';
import 'dart:ui' as ui;
import 'package:pointer_interceptor/pointer_interceptor.dart';
import 'bg.dart';

final registeredPvd=[];
class sitePreview extends StatelessWidget {
  final String? url;
  final double width;
  final double height;
  final bool interactive;
  final void Function()? onTap;
  final bool loading;
  final bool border;
  static const siteWidth=900;
  static const siteHeight=1200;
  sitePreview({required this.url,this.width=90,this.height=100,
    this.onTap,this.loading=false,this.interactive=false,this.border=true}){
    final x_scale=width/siteWidth;
    final y_scale=height/siteHeight;

    // if(registeredPvd.contains(url))
    //   return;
    // else registeredPvd.add(url);

    // ignore: undefined_prefixed_name
    ui.platformViewRegistry.registerViewFactory(
        url!,
            (int viewId) => IFrameElement()
          ..style.width="${siteWidth}px"
          ..style.height = '${siteHeight}px'
          ..style.transform="translate(-${(siteWidth*((1-x_scale)/2)).toInt()}px,-${(siteHeight*((1-y_scale)/2)).toInt()}px) scale($x_scale,$y_scale)"// translate(-100px,-100px)"
        // ..width = '4px'
        // ..height = '6px'
          ..src = url
        // ..scrollLeft=1000
        // ..offse
          ..style.border = '1px solid black');
  }
  @override
  Widget build(BuildContext context) {
    if(url==null)return Icon(Icons.error);
    
    return ConstrainedBox(constraints: BoxConstraints(maxWidth: width,maxHeight: height),
        child: Stack(fit: StackFit.passthrough,
            children:[HtmlElementView(viewType: url!),
          if(!interactive)PointerInterceptor(child: GestureDetector(child:Container(width: width+9, height: height+9,
            constraints: BoxConstraints(maxHeight: height+9,minHeight:height+9,maxWidth: width+9,minWidth: width+9),
            decoration: BoxDecoration(border: border?Border.all(color: cTheme.of(context).data.textColor):null,
                borderRadius: border?BorderRadius.circular(9):null,color: Colors.transparent),
            child: loading?Loading():null,
          ),onTap: onTap,)),
          // if(onTap!=null)GestureDetector(child:SizedBox(width: width.toDouble(), height: height.toDouble(),),
          //   onTap: onTap,)
        ]));
  }
}
